Blob


1 #! /bin/sh
2 #
3 # Copyright (c) 2014, 2015, 2016 Ingo Schwarze <schwarze@openbsd.org>
4 # Copyright (c) 2017, 2018 Kristaps Dzonsons <kristaps@bsd.lv>
5 # Copyright (c) 2022 Omar Polo <op@omarpolo.com>
6 #
7 # Permission to use, copy, modify, and distribute this software for any
8 # purpose with or without fee is hereby granted, provided that the above
9 # copyright notice and this permission notice appear in all copies.
10 #
11 # THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
12 # WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
13 # MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
14 # ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
15 # WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
16 # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
17 # OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
19 OCONFIGURE_VERSION="0.3.8"
21 #
22 # This script outputs two files: config.h and Makefile.configure.
23 # It tries to read from configure.local, which contains predefined
24 # values we won't autoconfigure.
25 #
26 # If you want to use configure with your project, have your GNUmakefile
27 # or BSDmakefile---whichever---try to import/include Makefile.configure
28 # at the beginning of the file.
29 #
30 # Like so (note no quotes, no period, etc.):
31 #
32 # include Makefile.configure
33 #
34 # If it exists, configure was run; otherwise, it wasn't.
35 #
36 # You'll probably want to change parts of this file. I've noted the
37 # parts that you'll probably change in the section documentation.
38 #
39 # See https://github.com/kristapsdz/oconfigure for more.
41 set -e
43 # try to be helpful
44 case "$1" in
45 --help|-h)
46 cat <<EOF
47 \`configure' configures lstun to adapt to many kinds of systems.
49 Usage: $0 [-h] [--prefix=path] [VAR=VALUE]...
51 The options are as follows:
53 -h, --help print this help message
55 --prefix=path equivalent to specifying the PREFIX variable, supported
56 for compatibility with other common "configure" scripts.
58 Variables available:
60 SSH_PROG absolute path to the ssh(1) binary
61 LDADD generic linker flags
62 LDADD_LIBEVENT linker flags for libevent
63 LDADD_LIBEVENT2 linker flags for libevent2
64 LDADD_LIBSOCKET linker flags for libsocket
65 LDFLAGS extra linker flags
66 CPPFLAGS C preprocessors flags
67 DESTDIR destination directory
68 PREFIX where to install files
69 MANDIR where to install man pages (PREFIX/man)
70 LIBDIR where to install libraries (PREFIX/lib)
71 BINDIR where to install executables (PREFIX/bin)
72 SHAREDIR where to install misc files (PREFIX/share)
73 SBINDIR where to install system executables (PREFIX/sbin)
74 INCLUDEDIR where to install header files (PREFIX/include)
75 PKG_CONFIG path to the pkg-config program or \`false'
77 Additionally, the following environment variables are used if set:
79 CC the C compiler to use (defaults to cc, clang or gcc)
80 CFLAGS generic C compiler flags
82 EOF
83 exit 0 ;;
84 esac
86 #----------------------------------------------------------------------
87 # Prepare for running: move aside previous configure runs.
88 # Output file descriptor usage:
89 # 1 (stdout): config.h or Makefile.configure
90 # 2 (stderr): original stderr, usually to the console
91 # 3: config.log
92 # You DO NOT want to change this.
93 #----------------------------------------------------------------------
95 [ -w config.log ] && mv config.log config.log.old
96 [ -w config.h ] && mv config.h config.h.old
98 exec 3> config.log
99 echo "config.log: writing..."
101 # GNU submake prints different output if invoked recursively, which
102 # messes up CC and CFLAGS detection. Pass --no-print-directory if
103 # we have a MAKELEVEL (GNU and FreeBSD make) and the argument is
104 # allowed.
106 MAKE_FLAGS=""
108 if [ -n "${MAKELEVEL}" ]; then
109 if [ "${MAKELEVEL}" -gt 0 ] ; then
110 MAKE_FLAGS="--no-print-directory"
111 echo "all:" | make ${MAKE_FLAGS} -sf - 2>/dev/null || MAKE_FLAGS=""
112 fi
113 fi
115 if [ -n "$MAKE_FLAGS" ]; then
116 echo "GNU submake detected: using --no-print-directory" 1>&2
117 echo "GNU submake detected: using --no-print-directory" 1>&3
118 fi
120 #----------------------------------------------------------------------
121 # Initialize all variables here such that nothing can leak in from the
122 # environment except for CC and CFLAGS, which we might have passed in.
123 #----------------------------------------------------------------------
125 CC=`printf "all:\\n\\t@echo \\\$(CC)\\n" | make ${MAKE_FLAGS} -sf -`
126 CFLAGS=`printf "all:\\n\\t@echo \\\$(CFLAGS)\\n" | make ${MAKE_FLAGS} -sf -`
127 CFLAGS="${CFLAGS} -g -W -Wall -Wmissing-prototypes -Wstrict-prototypes"
128 CFLAGS="${CFLAGS} -Wmissing-declarations -Wno-unused-parameter"
129 CFLAGS="${CFLAGS} -Wno-sign-compare"
130 LDADD=
131 LDADD_LIBEVENT=
132 LDADD_LIBEVENT2=
133 LDADD_LIB_SOCKET=
134 LDADD_STATIC=
135 CPPFLAGS=
136 LDFLAGS=
137 DESTDIR=
138 PREFIX="/usr/local"
139 BINDIR=
140 SBINDIR=
141 INCLUDEDIR=
142 LIBDIR=
143 MANDIR=
144 SHAREDIR=
145 INSTALL="install"
146 INSTALL_PROGRAM=
147 INSTALL_LIB=
148 INSTALL_MAN=
149 INSTALL_DATA=
150 PKG_CONFIG=
151 SSH_PROG=
153 # SunOS sets "cc", but this doesn't exist.
154 # It does have gcc, so try that instead.
155 # Prefer clang, though.
157 command -v ${CC} 2>/dev/null 1>&2 || {
158 echo "${CC} not found: trying clang" 1>&2
159 echo "${CC} not found: trying clang" 1>&3
160 CC=clang
161 command -v ${CC} 2>/dev/null 1>&2 || {
162 echo "${CC} not found: trying gcc" 1>&2
163 echo "${CC} not found: trying gcc" 1>&3
164 CC=gcc
165 command -v ${CC} 2>/dev/null 1>&2 || {
166 echo "gcc not found: giving up" 1>&2
167 echo "gcc not found: giving up" 1>&3
168 exit 1
173 #----------------------------------------------------------------------
174 # Allow certain variables to be overriden on the command line.
175 #----------------------------------------------------------------------
177 while [ $# -gt 0 ]; do
178 key=${1%%=*}
179 val=${1#*=}
181 if [ "$key" = "--prefix" ]; then
182 key=PREFIX
183 if [ "$1" = "--prefix" ]; then
184 if ! shift 2>&1 >/dev/null; then
185 echo "$0: missing value for --prefix" 1>&2
186 exit 1
187 fi
188 val="$1"
189 fi
190 fi
192 if [ "$1" = "$key" ]; then
193 echo "$0: invalid key-value: $1" 1>&2
194 exit 1
195 fi
197 shift
199 case "$key" in
200 LDADD)
201 LDADD="$val" ;;
202 LDADD_LIBEVENT)
203 LDADD_LIBEVENT="$val" ;;
204 LDADD_LIBEVENT2)
205 LDADD_LIBEVENT2="$val" ;;
206 LDADD_LIBSOCKET)
207 LDADD_LIBSOCKET="$val" ;;
208 LDFLAGS)
209 LDFLAGS="$val" ;;
210 CPPFLAGS)
211 CPPFLAGS="$val" ;;
212 DESTDIR)
213 DESTDIR="$val" ;;
214 PREFIX)
215 PREFIX="$val" ;;
216 MANDIR)
217 MANDIR="$val" ;;
218 LIBDIR)
219 LIBDIR="$val" ;;
220 BINDIR)
221 BINDIR="$val" ;;
222 SHAREDIR)
223 SHAREDIR="$val" ;;
224 SBINDIR)
225 SBINDIR="$val" ;;
226 INCLUDEDIR)
227 INCLUDEDIR="$val" ;;
228 PKG_CONFIG)
229 PKG_CONFIG="$val" ;;
230 SSH_PROG)
231 SSH_PROG="$val" ;;
232 *)
233 echo "$0: invalid key: $key" 1>&2
234 exit 1
235 esac
236 done
238 test -z "${PKG_CONFIG}" && {
239 command -v pkg-config 2>/dev/null >&2 && {
240 PKG_CONFIG="$(command -v pkg-config)"
241 echo "found pkg-config: $PKG_CONFIG" 1>&2
242 echo "found pkg-config: $PKG_CONFIG" 1>&3
243 } || {
244 PKG_CONFIG=false
245 echo "pkg-config not found" 1>&2
246 echo "pkg-config not found" 1>&3
250 test -z "${SSH_PROG}" && {
251 command -v ssh 2>/dev/null 1>&2 && {
252 SSH_PROG="$(command -v ssh)"
253 echo "found ssh: $SSH_PROG" 1>&2
254 echo "found ssh: $SSH_PROG" 1>&3
255 } || {
256 echo "ssh not found: giving up" >&2
257 echo "ssh not found: giving up" >&3
258 exit 1
263 #----------------------------------------------------------------------
264 # These are the values that will be pushed into config.h after we test
265 # for whether they're supported or not.
266 # Each of these must have a runtest(), below.
267 # Please sort by alpha, for clarity.
268 # You WANT to change this.
269 #----------------------------------------------------------------------
271 HAVE_GETEXECNAME=
272 HAVE_GETPROGNAME=
273 HAVE_LIBEVENT=
274 HAVE_LIBEVENT2=0 # may not be checked
275 HAVE_PLEDGE=
276 HAVE_PROGRAM_INVOCATION_SHORT_NAME=
277 HAVE_PR_SET_NAME=
278 HAVE_STRLCAT=
279 HAVE_STRLCPY=
280 HAVE_STRTONUM=
281 HAVE_UNVEIL=
282 HAVE___PROGNAME=
284 #----------------------------------------------------------------------
285 # Allow configure.local to override all variables, default settings,
286 # command-line arguments, and tested features, above.
287 # You PROBABLY DO NOT want to change this.
288 #----------------------------------------------------------------------
290 if [ -r ./configure.local ]; then
291 echo "configure.local: reading..." 1>&2
292 echo "configure.local: reading..." 1>&3
293 cat ./configure.local 1>&3
294 . ./configure.local
295 else
296 echo "configure.local: no (fully automatic configuration)" 1>&2
297 echo "configure.local: no (fully automatic configuration)" 1>&3
298 fi
300 echo 1>&3
302 #----------------------------------------------------------------------
303 # Infrastructure for running tests.
304 # These consists of a series of functions that will attempt to run the
305 # given test file and record its exit into a HAVE_xxx variable.
306 # You DO NOT want to change this.
307 #----------------------------------------------------------------------
309 COMP="${CC} ${CFLAGS} ${CPPFLAGS} -Wno-unused -Werror"
311 # Check whether this HAVE_ setting is manually overridden.
312 # If yes, use the override, if no, do not decide anything yet.
313 # Arguments: lower-case test name, manual value
315 ismanual() {
316 [ -z "${3}" ] && return 1
317 echo "${1}: manual (HAVE_${2}=${3})" 1>&2
318 echo "${1}: manual (HAVE_${2}=${3})" 1>&3
319 echo 1>&3
320 return 0
323 # Run a single autoconfiguration test.
324 # In case of success, enable the feature.
325 # In case of failure, do not decide anything yet.
326 # Arguments: lower-case test name, upper-case test name, additional
327 # CFLAGS, additional LIBS.
329 singletest() {
330 extralib=""
331 pkgcfs=""
332 pkglib=""
334 cat 1>&3 <<EOF
335 ${1}: testing...
336 ${COMP} -DTEST_${2} ${3} -o test-${1} tests.c ${LDFLAGS} ${4}
337 EOF
338 if ${COMP} -DTEST_${2} ${3} -o "test-${1}" tests.c ${LDFLAGS} ${4} 1>&3 2>&3; then
339 echo "${1}: ${CC} succeeded" 1>&3
340 else
341 if [ -n "${5}" ] ; then
342 echo "${1}: ${CC} failed with $? (retrying)" 1>&3
343 cat 1>&3 <<EOF
344 ${1}: testing...
345 ${COMP} -DTEST_${2} ${3} -o test-${1} tests.c ${LDFLAGS} ${5}
346 EOF
347 if ${COMP} -DTEST_${2} ${3} -o "test-${1}" tests.c ${LDFLAGS} ${5} 1>&3 2>&3; then
348 echo "${1}: ${CC} succeeded" 1>&3
349 extralib="(with ${5})"
350 else
351 test -n "${6}" && ${PKG_CONFIG} "$6"
352 if [ $? -eq 0 ]; then
353 echo "${1}: ${CC} failed with $? (retrying)" 1>&3
354 pkgcfs=$($PKG_CONFIG --cflags "${6}")
355 pkglib=$($PKG_CONFIG --libs "${6}")
356 cat 1>&3 <<EOF
357 ${1}: testing...
358 ${COMP} -DTEST_${2} ${3} ${pkgcfs} -o test-${1} tests.c ${LDFLAGS} ${pkglib}
359 EOF
360 if ${COMP} -DTEST_${2} ${3} ${pkgcfs} -o test-${1} tests.c ${LDFLAGS} ${pkglib} 1>&3 2>&3; then
361 echo "${1}: ${CC} succeeded" 1>&3
362 extralib="(with ${pkgcfs} ${pkglib})"
363 else
364 echo "${1}: ${CC} failed with $?" 1>&3
365 echo 1>&3
366 return 1
367 fi
368 else
369 echo "${1}: ${CC} failed with $?" 1>&3
370 echo 1>&3
371 return 1
372 fi
373 fi
374 else
375 echo "${1}: ${CC} failed with $?" 1>&3
376 echo 1>&3
377 return 1
378 fi
379 fi
381 rm -f test-${1}.d
383 if [ -n "${pkgcfs}" -o -n "${pkglib}" ]
384 then
385 CFLAGS="${CFLAGS} ${pkgcfs}"
386 eval "LDADD_${2}=\"${pkglib}\""
387 elif [ -n "${extralib}" ]
388 then
389 eval "LDADD_${2}=\"${5}\""
390 elif [ -n "${4}" ]
391 then
392 eval "LDADD_${2}=\"${4}\""
393 fi
395 echo "${1}: yes ${extralib}" 1>&2
396 echo "${1}: yes ${extralib}" 1>&3
397 echo 1>&3
398 eval HAVE_${2}=1
399 rm "test-${1}"
400 return 0
403 # Run a complete autoconfiguration test, including the check for
404 # a manual override and disabling the feature on failure.
405 # Arguments: lower case name, upper case name, additional CFLAGS,
406 # additional LDADD, alternative LDADD, pkg-config name.
408 runtest() {
409 eval _manual=\${HAVE_${2}}
410 ismanual "${1}" "${2}" "${_manual}" && return 0
411 singletest "${1}" "${2}" "${3}" "${4}" "${5}" "${6}" && return 0
412 echo "${1}: no" 1>&2
413 eval HAVE_${2}=0
414 return 1
417 #----------------------------------------------------------------------
418 # Begin running the tests themselves.
419 # All of your tests must be defined here.
420 # Please sort as the HAVE_xxxx values were defined.
421 # You WANT to change this.
422 # It consists of the following columns:
423 # runtest
424 # (1) test file
425 # (2) macro to set
426 # (3) argument to cc *before* -o
427 # (4) argument to cc *after*
428 # (5) alternative argument to cc *after*
429 # (6) name for pkg-config auto-discovery
430 #----------------------------------------------------------------------
432 if runtest -MMD _MMD -MMD; then
433 CFLAGS="${CFLAGS} -MMD"
434 echo "adding -MMD to CFLAGS" 1>&2
435 echo "adding -MMD to CFLAGS" 1>&3
436 fi
438 runtest getexecname GETEXECNAME || true
439 runtest getprogname GETPROGNAME || true
441 runtest libevent LIBEVENT "" "" "-levent" || \
442 runtest libevent2 LIBEVENT2 "" "" "-levent_extra -levent_core" "libevent" || true
444 runtest lib_socket LIB_SOCKET "" "" "-lsocket -lnsl" || true
445 runtest pledge PLEDGE || true
446 runtest program_invocation_short_name PROGRAM_INVOCATION_SHORT_NAME || true
447 runtest PR_SET_NAME PR_SET_NAME || true
448 runtest static STATIC "" "-static" || true
449 runtest strlcat STRLCAT || true
450 runtest strlcpy STRLCPY || true
451 runtest strtonum STRTONUM || true
452 runtest unveil UNVEIL || true
453 runtest __progname __PROGNAME || true
455 if [ "${HAVE_LIBEVENT}" -eq 0 -a "${HAVE_LIBEVENT2}" -eq 0 ]; then
456 echo "Fatal: missing libevent" 1>&2
457 echo "Fatal: missing libevent" 1>&3
458 exit 1
459 fi
461 #----------------------------------------------------------------------
462 # Output writing: generate the config.h file.
463 # This file contains all of the HAVE_xxxx variables necessary for
464 # compiling your source.
465 # You must include "config.h" BEFORE any other variables.
466 # You WANT to change this.
467 #----------------------------------------------------------------------
469 exec > config.h
471 # Start with prologue.
473 cat <<EOF
474 #ifndef OCONFIGURE_CONFIG_H
475 #define OCONFIGURE_CONFIG_H
477 #ifdef __cplusplus
478 # error "Do not use C++: this is a C application."
479 #endif
480 #if !defined(__GNUC__) || (__GNUC__ < 4)
481 # define __attribute__(x)
482 #endif
483 #if defined(__linux__) || defined(__MINT__)
484 # define _GNU_SOURCE /* memmem, memrchr, setresuid... */
485 # define _DEFAULT_SOURCE /* le32toh, crypt, ... */
486 #endif
487 #if defined(__NetBSD__)
488 # define _OPENBSD_SOURCE /* reallocarray, etc. */
489 #endif
490 #if defined(__sun)
491 # ifndef _XOPEN_SOURCE /* SunOS already defines */
492 # define _XOPEN_SOURCE /* XPGx */
493 # endif
494 # define _XOPEN_SOURCE_EXTENDED 1 /* XPG4v2 */
495 # ifndef __EXTENSIONS__ /* SunOS already defines */
496 # define __EXTENSIONS__ /* reallocarray, etc. */
497 # endif
498 #endif
499 #if !defined(__BEGIN_DECLS)
500 # define __BEGIN_DECLS
501 #endif
502 #if !defined(__END_DECLS)
503 # define __END_DECLS
504 #endif
506 EOF
508 # This is just for size_t, mode_t, and dev_t.
509 # Most of these functions, in the real world, pull in <string.h> or
510 # someting that pulls in support for size_t.
511 # Our function declarations are standalone, so specify them here.
513 if [ ${HAVE_STRLCAT} -eq 0 -o \
514 ${HAVE_STRLCPY} -eq 0 ]
515 then
516 echo "#include <sys/types.h> /* size_t, mode_t, dev_t */ "
517 echo
518 fi
520 if [ ${HAVE_GETPROGNAME} -eq 0 ]; then
521 echo "#include <stdlib.h>"
522 echo
523 fi
525 if [ ${HAVE_PLEDGE} -eq 0 -o ${HAVE_UNVEIL} -eq 0 ]; then
526 echo "#include <unistd.h>"
527 echo
528 fi
530 if [ ${HAVE_LIBEVENT2} -eq 1 ]; then
531 cat <<EOF
532 #include <event2/event.h>
533 #include <event2/event_compat.h>
534 #include <event2/event_struct.h>
535 #include <event2/buffer.h>
536 #include <event2/buffer_compat.h>
537 #include <event2/bufferevent.h>
538 #include <event2/bufferevent_struct.h>
539 #include <event2/bufferevent_compat.h>
540 EOF
541 fi
543 if [ ${HAVE_LIBEVENT} -eq 1 ]; then
544 cat <<EOF
545 #include <event.h>
546 EOF
547 fi
549 # Now we handle our HAVE_xxxx values.
550 # Most will just be defined as 0 or 1.
552 cat <<EOF
554 /*
555 * Results of configuration feature-testing.
556 */
557 #define HAVE_GETEXECNAME ${HAVE_GETEXECNAME}
558 #define HAVE_GETPROGNAME ${HAVE_GETPROGNAME}
559 #define HAVE_PLEDGE ${HAVE_PLEDGE}
560 #define HAVE_PROGRAM_INVOCATION_SHORT_NAME ${HAVE_PROGRAM_INVOCATION_SHORT_NAME}
561 #define HAVE_PR_SET_NAME ${HAVE_PR_SET_NAME}
562 #define HAVE_STRLCAT ${HAVE_STRLCAT}
563 #define HAVE_STRLCPY ${HAVE_STRLCPY}
564 #define HAVE_STRTONUM ${HAVE_STRTONUM}
565 #define HAVE_UNVEIL ${HAVE_UNVEIL}
566 #define HAVE___PROGNAME ${HAVE___PROGNAME}
568 /* Now we do our function declarations for missing functions. */
570 #if !HAVE_GETPROGNAME
571 extern const char *getprogname(void);
572 #endif
574 #if !HAVE_STRLCAT
575 extern size_t strlcat(char *, const char *, size_t);
576 #endif
578 #if !HAVE_STRLCPY
579 extern size_t strlcpy(char *, const char *, size_t);
580 #endif
582 #if !HAVE_STRTONUM
583 extern long long strtonum(const char *, long long, long long, const char **);
584 #endif
586 #ifndef __dead
587 # define __dead __attribute__((noreturn))
588 #endif
590 #define SSH_PROG "${SSH_PROG}"
592 #endif /*!OCONFIGURE_CONFIG_H*/
593 EOF
595 echo "config.h: written" 1>&2
596 echo "config.h: written" 1>&3
598 #----------------------------------------------------------------------
599 # Now we go to generate our Makefile.configure.
600 # This file is simply a bunch of Makefile variables.
601 # They'll work in both GNUmakefile and BSDmakefile.
602 # You MIGHT want to change this.
603 #----------------------------------------------------------------------
605 exec > Makefile.configure
607 [ -z "${BINDIR}" ] && BINDIR="${PREFIX}/bin"
608 [ -z "${SBINDIR}" ] && SBINDIR="${PREFIX}/sbin"
609 [ -z "${INCLUDEDIR}" ] && INCLUDEDIR="${PREFIX}/include"
610 [ -z "${LIBDIR}" ] && LIBDIR="${PREFIX}/lib"
611 [ -z "${MANDIR}" ] && MANDIR="${PREFIX}/man"
612 [ -z "${SHAREDIR}" ] && SHAREDIR="${PREFIX}/share"
614 [ -z "${INSTALL_PROGRAM}" ] && INSTALL_PROGRAM="${INSTALL} -m 0555"
615 [ -z "${INSTALL_LIB}" ] && INSTALL_LIB="${INSTALL} -m 0444"
616 [ -z "${INSTALL_MAN}" ] && INSTALL_MAN="${INSTALL} -m 0444"
617 [ -z "${INSTALL_DATA}" ] && INSTALL_DATA="${INSTALL} -m 0444"
619 cat <<EOF
620 CC = ${CC}
621 CFLAGS = ${CFLAGS}
622 CPPFLAGS = ${CPPFLAGS}
623 LDADD = ${LDADD} ${LDADD_LIB_SOCKET} ${LDADD_LIBEVENT} ${LDADD_LIBEVENT2}
624 LDADD_STATIC = ${LDADD_STATIC}
625 LDFLAGS = ${LDFLAGS}
626 PREFIX = ${PREFIX}
627 BINDIR = ${BINDIR}
628 SHAREDIR = ${SHAREDIR}
629 SBINDIR = ${SBINDIR}
630 INCLUDEDIR = ${INCLUDEDIR}
631 LIBDIR = ${LIBDIR}
632 MANDIR = ${MANDIR}
633 INSTALL = ${INSTALL}
634 INSTALL_PROGRAM = ${INSTALL_PROGRAM}
635 INSTALL_LIB = ${INSTALL_LIB}
636 INSTALL_MAN = ${INSTALL_MAN}
637 INSTALL_DATA = ${INSTALL_DATA}
638 EOF
640 echo "Makefile.configure: written" 1>&2
641 echo "Makefile.configure: written" 1>&3
643 exit 0